"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEmotionSsrAdvancedApproach = void 0;
const React = __importStar(require("react"));
const create_instance_1 = __importDefault(require("@emotion/server/create-instance"));
const react_1 = require("@emotion/react");
const cache_1 = __importDefault(require("@emotion/cache"));
const document_1 = __importDefault(require("next/document"));
const assert_1 = require("tsafe/assert");
/**
 * @see <https://docs.tss-react.dev/ssr/next>
 * This utility implements https://emotion.sh/docs/ssr#advanced-approach
 * */
function createEmotionSsrAdvancedApproach(
/** This is the options passed to createCache() from 'import createCache from "@emotion/cache"' */
options, 
/** By default <CacheProvider /> from 'import { CacheProvider } from "@emotion/react"' */
CacheProvider = react_1.CacheProvider) {
    const { prepend } = options, optionsWithoutPrependProp = __rest(options, ["prepend"]);
    const appPropName = `${options.key}EmotionCache`;
    const insertionPointId = `${options.key}-emotion-cache-insertion-point`;
    function augmentDocumentWithEmotionCache(Document) {
        var _a, _b;
        const super_getInitialProps = (_b = (_a = Document.getInitialProps) === null || _a === void 0 ? void 0 : _a.bind(Document)) !== null && _b !== void 0 ? _b : document_1.default.getInitialProps.bind(document_1.default);
        Document.getInitialProps = (appContext) => __awaiter(this, void 0, void 0, function* () {
            const cache = (0, cache_1.default)(optionsWithoutPrependProp);
            const emotionServer = (0, create_instance_1.default)(cache);
            const originalRenderPage = appContext.renderPage;
            appContext.renderPage = (_a) => {
                var { enhanceApp } = _a, params = __rest(_a, ["enhanceApp"]);
                return originalRenderPage(Object.assign(Object.assign({}, params), { "enhanceApp": (App) => {
                        var _a;
                        const EnhancedApp = (_a = enhanceApp === null || enhanceApp === void 0 ? void 0 : enhanceApp(App)) !== null && _a !== void 0 ? _a : App;
                        return function EnhanceApp(props) {
                            return (React.createElement(EnhancedApp, Object.assign({}, Object.assign(Object.assign({}, props), { [appPropName]: cache }))));
                        };
                    } }));
            };
            const initialProps = yield super_getInitialProps(appContext);
            const emotionStyles = [
                React.createElement("style", { id: insertionPointId }),
                ...emotionServer
                    .extractCriticalToChunks(initialProps.html)
                    .styles.filter(({ css }) => css !== "")
                    .map(style => (React.createElement("style", { "data-emotion": `${style.key} ${style.ids.join(" ")}`, key: style.key, dangerouslySetInnerHTML: { "__html": style.css } }))),
            ];
            const otherStyles = React.Children.toArray(initialProps.styles);
            return Object.assign(Object.assign({}, initialProps), { "styles": prepend
                    ? [...emotionStyles, ...otherStyles]
                    : [...otherStyles, ...emotionStyles] });
        });
    }
    function withAppEmotionCache(App) {
        const createClientSideCache = (() => {
            let cache = undefined;
            return () => {
                if (cache !== undefined) {
                    return cache;
                }
                return (cache = (0, cache_1.default)(Object.assign(Object.assign({}, optionsWithoutPrependProp), { "insertionPoint": (() => {
                        //NOTE: We know for sure we are on the client
                        const htmlElement = document.getElementById(insertionPointId);
                        (0, assert_1.assert)(htmlElement !== null);
                        return htmlElement;
                    })() })));
            };
        })();
        function AppWithEmotionCache(props) {
            const _a = props, _b = appPropName, cache = _a[_b], rest = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
            return (React.createElement(CacheProvider, { value: cache !== null && cache !== void 0 ? cache : createClientSideCache() },
                React.createElement(App, Object.assign({}, rest))));
        }
        Object.keys(App).forEach(staticMethod => (AppWithEmotionCache[staticMethod] = App[staticMethod]));
        AppWithEmotionCache.displayName = AppWithEmotionCache.name;
        return AppWithEmotionCache;
    }
    return { withAppEmotionCache, augmentDocumentWithEmotionCache };
}
exports.createEmotionSsrAdvancedApproach = createEmotionSsrAdvancedApproach;
